'************************************************************************
'*                                                                       *
'* Open Dynamics Engine, Copyright (C) 2001-2003 Russell L. Smith.       *
'* All rights reserved.  Email: russ@q12.org   Web: www.q12.org          *
'*                                                                       *
'* Ported to Rapid-Q by Julien Moog - julien.moog@laposte.net            *
'*                                                                       *
'* This library is free software; you can redistribute it and/or         *
'* modify it under the terms of EITHER:                                  *
'*   (1) The GNU Lesser General Public License as published by the Free  *
'*       Software Foundation; either version 2.1 of the License, or (at  *
'*       your option) any later version. The text of the GNU Lesser      *
'*       General Public License is included with this library in the     *
'*       file LICENSE.TXT.                                               *
'*   (2) The BSD-style license that is included with this library in     *
'*       the file LICENSE-BSD.TXT.                                       *
'*                                                                       *
'* This library is distributed in the hope that it will be useful,       *
'* but WITHOUT ANY WARRANTY; without even the implied warranty of        *
'* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the files    *
'* LICENSE.TXT and LICENSE-BSD.TXT for more details.                     *
'*                                                                       *
'************************************************************************'/

Const dParamLoStop 			= 0
Const dParamHiStop			= 1
Const dParamVel				= 2
Const dParamVel2			= 258
Const dParamFMax			= 3
Const dParamFMax2			= 259
Const dParamFudgeFactor		= 4
Const dParamBounce			= 5
Const dParamCFM				= 6
Const dParamStopERP			= 7
Const dParamStopCFM			= 8
Const dParamSuspensionERP	= 9
Const dParamSuspensionCFM	= 10

const dContactMu2       = &h0001
const dContactFDir1     = &h0002
const dContactBounce    = &h0004
const dContactSoftERP   = &h0008
const dContactSoftCFM   = &h0010
const dContactMotion1   = &h0020
const dContactMotion2   = &h0040
const dContactSlip1     = &h0080
const dContactSlip2     = &h0100
const dContactApprox0	= &H0000
const dContactApprox1_1 = &h1000
const dContactApprox1_2 = &h2000
const dContactApprox1   = &h3000

' ODE declarations

declare sub ODE_dSetContactMode lib "ODE.dll" alias "_ODE_dSetContactMode@4" (byval mode as long)
declare sub ODE_dSetMU lib "ODE.dll" alias "_ODE_dSetMU@4" (byval value as integer)
declare sub ODE_dSetMU2 lib "ODE.dll" alias "_ODE_dSetMU2@4" (byval value as integer)
declare sub ODE_dSetBOUNCE lib "ODE.dll" alias "_ODE_dSetBOUNCE@4" (byval value as integer)
declare sub ODE_dSetBOUNCE_VEL lib "ODE.dll" alias "_ODE_dSetBOUNCE_VEL@4" (byval value as integer)
declare sub ODE_dSetSLIP1 lib "ODE.dll" alias "_ODE_dSetSLIP1@4" (byval value as integer)
declare sub ODE_dSetSLIP2 lib "ODE.dll" alias "_ODE_dSetSLIP2@4" (byval value as integer)
declare sub ODE_dSetSOFT_ERP lib "ODE.dll" alias "_ODE_dSetSOFT_ERP@4" (byval value as integer)
declare sub ODE_dSetSOFT_CFM lib "ODE.dll" alias "_ODE_dSetSOFT_CFM@4" (byval value as integer)
declare sub ODE_dSetMOTION1 lib "ODE.dll" alias "_ODE_dSetMOTION1@4" (byval value as integer)
declare sub ODE_dSetMOTION2 lib "ODE.dll" alias "_ODE_dSetMOTION2@4" (byval value as integer)
declare function ODE_dBodyGetCollisionsCount lib "ODE.dll" alias "_ODE_dBodyGetCollisionsCount@4" (byval body as integer) as integer
declare function ODE_dBodyGetCollisionDepth lib "ODE.dll" alias "_ODE_dBodyGetCollisionDepth@8" (byval body as integer,byval num as integer) as double
declare function ODE_dBodyGetCollisionX lib "ODE.dll" alias "_ODE_dBodyGetCollisionX@8" (byval body as integer,byval num as integer) as double
declare function ODE_dBodyGetCollisionY lib "ODE.dll" alias "_ODE_dBodyGetCollisionY@8" (byval body as integer,byval num as integer) as double
declare function ODE_dBodyGetCollisionZ lib "ODE.dll" alias "_ODE_dBodyGetCollisionZ@8" (byval body as integer,byval num as integer) as double
declare function ODE_dBodyGetCollisionNX lib "ODE.dll" alias "_ODE_dBodyGetCollisionNX@8" (byval body as integer,byval num as integer) as double
declare function ODE_dBodyGetCollisionNY lib "ODE.dll" alias "_ODE_dBodyGetCollisionNY@8" (byval body as integer,byval num as integer) as double
declare function ODE_dBodyGetCollisionNZ lib "ODE.dll" alias "_ODE_dBodyGetCollisionNZ@8" (byval body as integer,byval num as integer) as double
declare function ODE_dBodyGetCollisionBody lib "ODE.dll" alias "_ODE_dBodyGetCollisionBody@8" (byval body as integer,byval num as integer) as integer
declare function ODE_dBodyGetCollisionGeom lib "ODE.dll" alias "_ODE_dBodyGetCollisionGeom@8" (byval body as integer,byval num as integer) as integer
declare function ODE_dBodyGetCollisionFX lib "ODE.dll" alias "_ODE_dBodyGetCollisionFX@8" (byval body as integer,byval num as integer) as double
declare function ODE_dBodyGetCollisionFY lib "ODE.dll" alias "_ODE_dBodyGetCollisionFY@8" (byval body as integer,byval num as integer) as double
declare function ODE_dBodyGetCollisionFZ lib "ODE.dll" alias "_ODE_dBodyGetCollisionFZ@8" (byval body as integer,byval num as integer) as double
declare function ODE_dWorldCreate lib "ODE.dll" alias "_ODE_dWorldCreate@4" (byval plane as integer) as integer
declare sub ODE_dWorldDestroy lib "ODE.dll" alias "_ODE_dWorldDestroy@0" ()
declare sub ODE_dWorldSetGravity lib "ODE.dll" alias "_ODE_dWorldSetGravity@12" (byval x as single,byval y as single,byval z as single)
declare sub ODE_dWorldSetERP lib "ODE.dll" alias "_ODE_dWorldSetERP@4" (byval erp as single)
declare function ODE_dWorldGetERP lib "ODE.dll" alias "_ODE_dWorldGetERP@0" () as single
declare sub ODE_dWorldSetCFM lib "ODE.dll" alias "_ODE_dWorldSetCFM@4" (byval cfm as single)
declare function ODE_dWorldGetCFM lib "ODE.dll" alias "_ODE_dWorldGetCFM@0" () as single
declare sub ODE_dWorldSetAutoDisableFlag lib "ODE.dll" alias "_ODE_dWorldSetAutoDisableFlag@4" (byval do_auto_disable as integer)
declare function ODE_dWorldGetAutoDisableFlag lib "ODE.dll" alias "_ODE_dWorldGetAutoDisableFlag@0" () as integer
declare sub ODE_dWorldSetAutoDisableLinearThreshold lib "ODE.dll" alias "_ODE_dWorldSetAutoDisableLinearThreshold@4" (byval linear_threshold as single)
declare function ODE_dWorldGetAutoDisableLinearThreshold lib "ODE.dll" alias "_ODE_dWorldGetAutoDisableLinearThreshold@0" () as single
declare sub ODE_dWorldSetAutoDisableAngularThreshold lib "ODE.dll" alias "_ODE_dWorldSetAutoDisableAngularThreshold@4" (byval linear_threshold as single)
declare function ODE_dWorldGetAutoDisableAngularThreshold lib "ODE.dll" alias "_ODE_dWorldGetAutoDisableAngularThreshold@0" () as single
declare sub ODE_dWorldSetAutoDisableSteps lib "ODE.dll" alias "_ODE_dWorldSetAutoDisableSteps@4" (byval steps as integer)
declare function ODE_dWorldGetAutoDisableSteps lib "ODE.dll" alias "_ODE_dWorldGetAutoDisableSteps@0" () as integer
declare sub ODE_dWorldSetAutoDisableTime lib "ODE.dll" alias "_ODE_dWorldSetAutoDisableTime@4" (byval steps as integer)
declare function ODE_dWorldGetAutoDisableTime lib "ODE.dll" alias "_ODE_dWorldGetAutoDisableTime@0" () as single
declare sub ODE_dWorldImpulseToForce lib "ODE.dll" alias "_ODE_dWorldImpulseToForce@28" (byval stepsize as single, byval ix as single, byval iy as single, byval iz as single, byval fx as single, byval fy as single, byval fz as single)
declare sub ODE_dCloseODE lib "ODE.dll" alias "_ODE_dCloseODE@0" ()
declare sub ODE_dWorldStep lib "ODE.dll" alias "_ODE_dWorldStep@4" (byval step as single)
declare sub ODE_dWorldQuickStep lib "ODE.dll" alias "_ODE_dWorldQuickStep@4" (byval step as integer)
declare sub ODE_dWorldSetQuickStepNumIterations lib "ODE.dll" alias "_ODE_dWorldSetQuickStepNumIterations@4" (byval num as integer)
declare function ODE_dWorldGetQuickStepNumIterations lib "ODE.dll" alias "_ODE_dWorldGetQuickStepNumIterations@0" () as integer
declare sub ODE_dWorldSetContactMaxCorrectingVel lib "ODE.dll" alias "_ODE_dWorldSetContactMaxCorrectingVel@4" (byval vel as single)
declare function ODE_dWorldGetContactMaxCorrectingVel lib "ODE.dll" alias "_ODE_dWorldGetContactMaxCorrectingVel@0" () as single
declare sub ODE_dWorldSetContactSurfaceLayer lib "ODE.dll" alias "_ODE_dWorldSetContactSurfaceLayer@4" (byval depth as single)
declare function ODE_dWorldGetContactSurfaceLayer lib "ODE.dll" alias "_ODE_dWorldGetContactSurfaceLayer@0" () as single

declare function ODE_dBodyCreate lib "ODE.dll" alias "_ODE_dBodyCreate@0" () as integer
declare sub ODE_dBodyDestroy lib "ODE.dll" alias "_ODE_dBodyDestroy@4" (byval body as integer)
declare sub ODE_dBodySetPosition lib "ODE.dll" alias "_ODE_dBodySetPosition@16" (byval body as integer, byval x as single, byval y as single, byval z as single)
declare sub ODE_dBodySetRotation lib "ODE.dll" alias "_ODE_dBodySetRotation@16" (byval body as integer, byval x as single, byval y as single, byval z as single)
declare sub ODE_dBodySetLinearVel lib "ODE.dll" alias "_ODE_dBodySetLinearVel@16" (byval body as integer, byval x as single, byval y as single, byval z as single)
declare sub ODE_dBodySetAngularVel lib "ODE.dll" alias "_ODE_dBodySetAngularVel@16" (byval body as integer, byval x as single, byval y as single, byval z as single)
declare function ODE_dBodyGetPositionX lib "ODE.dll" alias "_ODE_dBodyGetPositionX@4" (byval body as integer) as double
declare function ODE_dBodyGetPositionY lib "ODE.dll" alias "_ODE_dBodyGetPositionY@4" (byval body as integer) as double
declare function ODE_dBodyGetPositionZ lib "ODE.dll" alias "_ODE_dBodyGetPositionZ@4" (byval body as integer) as double
declare function ODE_dBodyGetPitch lib "ODE.dll" alias "_ODE_dBodyGetPitch@4" (byval body as integer) as double
declare function ODE_dBodyGetYaw lib "ODE.dll" alias "_ODE_dBodyGetYaw@4" (byval body as integer) as double
declare function ODE_dBodyGetRoll lib "ODE.dll" alias "_ODE_dBodyGetRoll@4" (byval body as integer) as double
declare function ODE_dBodyGetLinearVelX lib "ODE.dll" alias "_ODE_dBodyGetLinearVelX@4" (byval body as integer) as double

declare function ODE_dBodyGetLinearVelY lib "ODE.dll" alias "_ODE_dBodyGetLinearVelY@4" (byval body as integer) as double
declare function ODE_dBodyGetLinearVelZ lib "ODE.dll" alias "_ODE_dBodyGetLinearVelZ@4" (byval body as integer) as double
declare function ODE_dBodyGetAngularVelX lib "ODE.dll" alias "_ODE_dBodyGetAngularVelX@4" (byval body as integer) as double
declare function ODE_dBodyGetAngularVelY lib "ODE.dll" alias "_ODE_dBodyGetAngularVelY@4" (byval body as integer) as double
declare function ODE_dBodyGetAngularVelZ lib "ODE.dll" alias "_ODE_dBodyGetAngularVelZ@4" (byval body as integer) as double

declare sub ODE_dBodySetMass lib "ODE.dll" alias "_ODE_dBodySetMass@8" (byval body as integer, byval mass as integer)
declare sub ODE_dBodyTranslateMass lib "ODE.dll" alias "_ODE_dBodyTranslateMass@16" (byval body as integer,byval x as single,byval y as single,byval z as single)
declare sub ODE_dBodyAddForce lib "ODE.dll" alias "_ODE_dBodyAddForce@16" (byval body as integer,byval x as single,byval y as single,byval z as single)
declare sub ODE_dBodyAddTorque lib "ODE.dll" alias "_ODE_dBodyAddTorque@16" (byval body as integer,byval x as single,byval y as single,byval z as single)
declare sub ODE_dBodyAddRelForce lib "ODE.dll" alias "_ODE_dBodyAddRelForce@16" (byval body as integer,byval x as single,byval y as single,byval z as single)
declare sub ODE_dBodyAddRelTorque lib "ODE.dll" alias "_ODE_dBodyAddRelTorque@16" (byval body as integer,byval x as single,byval y as single,byval z as single)
declare sub ODE_dBodyAddForceAtPos lib "ODE.dll" alias "_ODE_dBodyAddForceAtPos@28" (byval body as integer,byval fx as single,byval fy as single,byval fz as single,byval px as single,byval py as single,byval pz as single)
declare sub ODE_dBodyAddForceAtRelPos lib "ODE.dll" alias "_ODE_dBodyAddForceAtRelPos@28" (byval body as integer,byval fx as single,byval fy as single,byval fz as single,byval px as single,byval py as single,byval pz as single)
declare sub ODE_dBodyAddRelForceAtPos lib "ODE.dll" alias "_ODE_dBodyAddRelForceAtPos@28" (byval body as integer,byval fx as single,byval fy as single,byval fz as single,byval px as single,byval py as single,byval pz as single)
declare sub ODE_dBodyAddRelForceAtRelPos lib "ODE.dll" alias "_ODE_dBodyAddRelForceAtRelPos@28" (byval body as integer,byval fx as single,byval fy as single,byval fz as single,byval px as single,byval py as single,byval pz as single)
declare function ODE_dBodyGetForceX lib "ODE.dll" alias "_ODE_dBodyGetForceX@4" (byval body as integer) as double
declare function ODE_dBodyGetForceY lib "ODE.dll" alias "_ODE_dBodyGetForceY@4" (byval body as integer) as double
declare function ODE_dBodyGetForceZ lib "ODE.dll" alias "_ODE_dBodyGetForceZ@4" (byval body as integer) as double
declare function ODE_dBodyGetTorqueX lib "ODE.dll" alias "_ODE_dBodyGetTorqueX@4" (byval body as integer) as double
declare function ODE_dBodyGetTorqueY lib "ODE.dll" alias "_ODE_dBodyGetTorqueY@4" (byval body as integer) as double
declare function ODE_dBodyGetTorqueZ lib "ODE.dll" alias "_ODE_dBodyGetTorqueZ@4" (byval body as integer) as double
declare sub ODE_dBodySetForce lib "ODE.dll" alias "_ODE_dBodySetForce@16" (byval body as integer,byval x as single,byval y as single,byval z as single)
declare sub ODE_dBodySetTorque lib "ODE.dll" alias "_ODE_dBodySetTorque@16" (byval body as integer,byval x as single,byval y as single,byval z as single)

declare function ODE_dBodyGetRelPointPosX lib "ODE.dll" alias "_ODE_dBodyGetRelPointPosX@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetRelPointPosY lib "ODE.dll" alias "_ODE_dBodyGetRelPointPosY@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetRelPointPosZ lib "ODE.dll" alias "_ODE_dBodyGetRelPointPosZ@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetRelPointVelX lib "ODE.dll" alias "_ODE_dBodyGetRelPointVelX@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetRelPointVelY lib "ODE.dll" alias "_ODE_dBodyGetRelPointVelY@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetRelPointVelZ lib "ODE.dll" alias "_ODE_dBodyGetRelPointVelZ@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetPointVelX lib "ODE.dll" alias "_ODE_dBodyGetPointVelX@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetPointVelY lib "ODE.dll" alias "_ODE_dBodyGetPointVelY@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetPointVelZ lib "ODE.dll" alias "_ODE_dBodyGetPointVelZ@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetPosRelPointX lib "ODE.dll" alias "_ODE_dBodyGetPosRelPointX@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetPosRelPointY lib "ODE.dll" alias "_ODE_dBodyGetPosRelPointY@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyGetPosRelPointZ lib "ODE.dll" alias "_ODE_dBodyGetPosRelPointZ@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as double
declare function ODE_dBodyVectorToWorldX lib "ODE.dll" alias "_ODE_dBodyVectorToWorldX@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as single
declare function ODE_dBodyVectorToWorldY lib "ODE.dll" alias "_ODE_dBodyVectorToWorldY@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as single
declare function ODE_dBodyVectorToWorldZ lib "ODE.dll" alias "_ODE_dBodyVectorToWorldZ@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as single
declare function ODE_dBodyVectorFromWorldX lib "ODE.dll" alias "_ODE_dBodyVectorFromWorldX@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as single
declare function ODE_dBodyVectorFromWorldY lib "ODE.dll" alias "_ODE_dBodyVectorFromWorldY@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as single
declare function ODE_dBodyVectorFromWorldZ lib "ODE.dll" alias "_ODE_dBodyVectorFromWorldZ@16" (byval body as integer,byval px as single,byval py as single,byval pz as single) as single
declare sub ODE_dBodyEnable lib "ODE.dll" alias "_ODE_dBodyEnable@4" (byval body as integer)
declare sub ODE_dBodyDisable lib "ODE.dll" alias "_ODE_dBodyDisable@4" (byval body as integer)
declare function ODE_dBodyIsEnabled lib "ODE.dll" alias "_ODE_dBodyIsEnabled@4" (byval body as integer) as integer
declare sub ODE_dBodySetAutoDisableFlag lib "ODE.dll" alias "_ODE_dBodySetAutoDisableFlag@8" (byval body as integer,byval do_auto_disable as integer)
declare function ODE_dBodyGetAutoDisableFlag lib "ODE.dll" alias "_ODE_dBodyGetAutoDisableFlag@4" (byval body as integer) as integer

declare sub ODE_dBodySetAutoDisableLinearThreshold lib "ODE.dll" alias "_ODE_dBodySetAutoDisableLinearThreshold@8" (byval body as integer,byval linear_threshold as single)
declare function ODE_dBodyGetAutoDisableLinearThreshold lib "ODE.dll" alias "_ODE_dBodyGetAutoDisableLinearThreshold@4" (byval body as integer) as single
declare sub ODE_dBodySetAutoDisableAngularThreshold lib "ODE.dll" alias "_ODE_dBodySetAutoDisableAngularThreshold@8" (byval body as integer,byval linear_threshold as single)
declare function ODE_dBodyGetAutoDisableAngularThreshold lib "ODE.dll" alias "_ODE_dBodyGetAutoDisableAngularThreshold@4" (byval body as integer) as single
declare function ODE_dBodySetAutoDisableTime lib "ODE.dll" alias "_ODE_dBodySetAutoDisableTime@8" (byval body as integer,byval time as single) as single
declare function ODE_dBodyGetAutoDisableTime lib "ODE.dll" alias "_ODE_dBodyGetAutoDisableTime@4" (byval body as integer) as single
declare sub ODE_dBodySetAutoDisableDefaults lib "ODE.dll" alias "_ODE_dBodySetAutoDisableDefaults@4" (byval body as integer)
declare sub ODE_dBodySetFiniteRotationMode lib "ODE.dll" alias "_ODE_dBodySetFiniteRotationMode@8" (byval body as integer,byval mode as integer)
declare function ODE_dBodyGetFiniteRotationMode lib "ODE.dll" alias "_ODE_dBodyGetFiniteRotationMode@4" (byval body as integer) as integer
declare function ODE_dBodySetFiniteRotationAxis lib "ODE.dll" alias "_ODE_dBodySetFiniteRotationAxis@16" (byval body as integer,byval x as single,byval y as single,byval z as single) as integer
declare function ODE_dBodyGetFiniteRotationAxisX lib "ODE.dll" alias "_ODE_dBodyGetFiniteRotationAxisX@4" (byval body as integer) as single
declare function ODE_dBodyGetFiniteRotationAxisY lib "ODE.dll" alias "_ODE_dBodyGetFiniteRotationAxisY@4" (byval body as integer) as single
declare function ODE_dBodyGetFiniteRotationAxisZ lib "ODE.dll" alias "_ODE_dBodyGetFiniteRotationAxisZ@4" (byval body as integer) as single
declare function ODE_dBodyGetNumJoints lib "ODE.dll" alias "_ODE_dBodyGetNumJoints@4" (byval body as integer) as integer
declare function ODE_dBodyGetJoint lib "ODE.dll" alias "_ODE_dBodyGetJoint@8" (byval body as integer,byval index as integer) as integer
declare sub ODE_dBodySetGravityMode lib "ODE.dll" alias "_ODE_dBodySetGravityMode@8" (byval body as integer,byval mode as integer)
declare function ODE_dBodyGetGravityMode lib "ODE.dll" alias "_ODE_dBodyGetGravityMode@4" (byval body as integer) as integer
declare function ODE_dJointCreateBall lib "ODE.dll" alias "_ODE_dJointCreateBall@0" () as integer
declare function ODE_dJointCreateHinge lib "ODE.dll" alias "_ODE_dJointCreateHinge@0" () as integer
declare function ODE_dJointCreateSlider lib "ODE.dll" alias "_ODE_dJointCreateSlider@0" () as integer
declare function ODE_dJointCreateUniversal lib "ODE.dll" alias "_ODE_dJointCreateUniversal@0" () as integer
declare function ODE_dJointCreateHinge2 lib "ODE.dll" alias "_ODE_dJointCreateHinge2@0" () as integer
declare function ODE_dJointCreateFixed lib "ODE.dll" alias "_ODE_dJointCreateFixed@0" () as integer

declare function ODE_dJointCreateAMotor lib "ODE.dll" alias "_ODE_dJointCreateAMotor@0" () as integer
declare sub ODE_dJointDestroy lib "ODE.dll" alias "_ODE_dJointDestroy@4" (byval joint as integer)
declare sub ODE_dJointAttach lib "ODE.dll" alias "_ODE_dJointAttach@12" (byval joint as integer, byval body1 as integer, byval body2 as integer)
declare sub ODE_dJointSetData lib "ODE.dll" alias "_ODE_dJointSetData@8" (byval joint as integer, byval data as long)
declare sub ODE_dJointGetData lib "ODE.dll" alias "_ODE_dJointGetData@8" (byval joint as integer, byval data as long)
declare function ODE_dJointGetType lib "ODE.dll" alias "_ODE_dJointGetType@4" (byval joint as integer) as integer
declare function ODE_dJointGetBody lib "ODE.dll" alias "_ODE_dJointGetBody@8" (byval joint as integer, byval index as integer) as integer
declare function ODE_dAreConnected lib "ODE.dll" alias "_ODE_dAreConnected@8" (byval body1 as integer, byval body2 as integer) as integer
declare function ODE_dAreConnectedExcluding lib "ODE.dll" alias "_ODE_dAreConnectedExcluding@12" (byval body1 as integer, byval body2 as integer, byval joint_type as integer) as integer
declare sub ODE_dJointSetBallAnchor lib "ODE.dll" alias "_ODE_dJointSetBallAnchor@16" (byval joint as integer, byval x as single, byval y as single, byval z as single)
declare function ODE_dJointGetBallAnchorX lib "ODE.dll" alias "_ODE_dJointGetBallAnchorX@4" (byval joint as integer) as single
declare function ODE_dJointGetBallAnchorY lib "ODE.dll" alias "_ODE_dJointGetBallAnchorY@4" (byval joint as integer) as single
declare function ODE_dJointGetBallAnchorZ lib "ODE.dll" alias "_ODE_dJointGetBallAnchorZ@4" (byval joint as integer) as single
declare function ODE_dJointGetBallAnchor2X lib "ODE.dll" alias "_ODE_dJointSetHingeAnchor@16" (byval joint as integer) as single
declare function ODE_dJointGetBallAnchor2Y lib "ODE.dll" alias "_ODE_dJointSetHingeAxis@16" (byval joint as integer) as single
declare function ODE_dJointGetBallAnchor2Z lib "ODE.dll" alias "_ODE_dJointGetHingeAnchorX@4" (byval joint as integer) as single
declare sub ODE_dJointSetHingeAnchor lib "ODE.dll" alias "_ODE_dJointGetHingeAnchorY@4" (byval joint as integer, byval x as single, byval y as single, byval z as single)
declare sub ODE_dJointSetHingeAxis lib "ODE.dll" alias "_ODE_dJointGetHingeAnchorZ@4" (byval joint as integer, byval x as single, byval y as single, byval z as single)
declare function ODE_dJointGetHingeAnchorX lib "ODE.dll" alias "_ODE_dJointGetHingeAnchor2X@4" (byval joint as integer) as single
declare function ODE_dJointGetHingeAnchorY lib "ODE.dll" alias "_ODE_dJointGetHingeAnchor2Y@4" (byval joint as integer) as single
declare function ODE_dJointGetHingeAnchorZ lib "ODE.dll" alias "_ODE_dJointGetHingeAnchor2Z@4" (byval joint as integer) as single
declare function ODE_dJointGetHingeAnchor2X lib "ODE.dll" alias "_ODE_dJointGetHingeAxisX@4" (byval joint as integer) as single
declare function ODE_dJointGetHingeAnchor2Y lib "ODE.dll" alias "_ODE_dJointGetHingeAxisY@4" (byval joint as integer) as single
declare function ODE_dJointGetHingeAnchor2Z lib "ODE.dll" alias "_ODE_dJointGetHingeAxisZ@4" (byval joint as integer) as single
declare function ODE_dJointGetHingeAxisX lib "ODE.dll" alias "_ODE_dJointGetHingeAngle@4" (byval joint as integer) as single
declare function ODE_dJointGetHingeAxisY lib "ODE.dll" alias "_ODE_dJointGetHingeAngleRate@4" (byval joint as integer) as single

declare function ODE_dJointGetHingeAxisZ lib "ODE.dll" alias "_ODE_dJointGetHingeAxisZ@4" (byval joint as integer) as single
declare function ODE_dJointGetHingeAngle lib "ODE.dll" alias "_ODE_dJointGetHingeAngle@4" (byval joint as integer) as single
declare function ODE_dJointGetHingeAngleRate lib "ODE.dll" alias "_ODE_dJointGetHingeAngleRate@4" (byval joint as integer) as single
declare sub ODE_dJointSetSliderAxis lib "ODE.dll" alias "_ODE_dJointSetSliderAxis@16" (byval joint as integer, byval x as single, byval y as single, byval z as single)
declare function ODE_dJointGetSliderAxisX lib "ODE.dll" alias "_ODE_dJointGetSliderAxisX@4" (byval joint as integer) as single
declare function ODE_dJointGetSliderAxisY lib "ODE.dll" alias "_ODE_dJointGetSliderAxisY@4" (byval joint as integer) as single
declare function ODE_dJointGetSliderAxisZ lib "ODE.dll" alias "_ODE_dJointGetSliderAxisZ@4" (byval joint as integer) as single
declare function ODE_dJointGetSliderPosition lib "ODE.dll" alias "_ODE_dJointGetSliderPosition@4" (byval joint as integer) as single
declare function ODE_dJointGetSliderPositionRate lib "ODE.dll" alias "_ODE_dJointGetSliderPositionRate@4" (byval joint as integer) as single
declare sub ODE_dJointSetUniversalAnchor lib "ODE.dll" alias "_ODE_dJointSetUniversalAnchor@16" (byval joint as integer, byval x as single, byval y as single, byval z as single)
declare sub ODE_dJointSetUniversalAxis1 lib "ODE.dll" alias "_ODE_dJointSetUniversalAxis1@16" (byval joint as integer, byval x as single, byval y as single, byval z as single)
declare sub ODE_dJointSetUniversalAxis2 lib "ODE.dll" alias "_ODE_dJointSetUniversalAxis2@16" (byval joint as integer, byval x as single, byval y as single, byval z as single)
declare function ODE_dJointGetUniversalAnchorX lib "ODE.dll" alias "_ODE_dJointGetUniversalAnchorX@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAnchorY lib "ODE.dll" alias "_ODE_dJointGetUniversalAnchorY@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAnchorZ lib "ODE.dll" alias "_ODE_dJointGetUniversalAnchorZ@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAnchor2X lib "ODE.dll" alias "_ODE_dJointGetUniversalAnchor2X@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAnchor2Y lib "ODE.dll" alias "_ODE_dJointGetUniversalAnchor2Y@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAnchor2Z lib "ODE.dll" alias "_ODE_dJointGetUniversalAnchor2Z@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAxis1X lib "ODE.dll" alias "_ODE_dJointGetUniversalAxis1X@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAxis1Y lib "ODE.dll" alias "_ODE_dJointGetUniversalAxis1Y@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAxis1Z lib "ODE.dll" alias "_ODE_dJointGetUniversalAxis1Z@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAxis2X lib "ODE.dll" alias "_ODE_dJointGetUniversalAxis2X@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAxis2Y lib "ODE.dll" alias "_ODE_dJointGetUniversalAxis2Y@4" (byval joint as integer) as single
declare function ODE_dJointGetUniversalAxis2Z lib "ODE.dll" alias "_ODE_dJointGetUniversalAxis2Z@4" (byval joint as integer) as single
declare sub ODE_dJointSetHinge2Anchor lib "ODE.dll" alias "_ODE_dJointSetHinge2Anchor@16" (byval joint as integer, byval x as single, byval y as single, byval z as single)
declare sub ODE_dJointSetHinge2Axis1 lib "ODE.dll" alias "_ODE_dJointSetHinge2Axis1@16" (byval joint as integer, byval x as single, byval y as single, byval z as single)

declare sub ODE_dJointSetAMotorAngle lib "ODE.dll" alias "_ODE_dJointSetAMotorAngle@12" (byval joint as integer, byval anum as integer, byval angle as single)
declare function ODE_dJointGetAMotorAngle lib "ODE.dll" alias "_ODE_dJointGetAMotorAngle@8" (byval joint as integer, byval anum as integer) as single
declare function ODE_dJointGetAMotorAngleRate lib "ODE.dll" alias "_ODE_dJointGetAMotorAngleRate@8" (byval joint as integer, byval anum as integer) as single
declare sub ODE_dJointSetHingeParam lib "ODE.dll" alias "_ODE_dJointSetHingeParam@12" (byval joint as integer, byval parameter as integer, byval value as single)
declare sub ODE_dJointSetSliderParam lib "ODE.dll" alias "_ODE_dJointSetSliderParam@12" (byval joint as integer, byval parameter as integer, byval value as single)
declare sub ODE_dJointSetHinge2Param lib "ODE.dll" alias "_ODE_dJointSetHinge2Param@12" (byval joint as integer, byval parameter as integer, byval value as single)
declare sub ODE_dJointSetUniversalParam lib "ODE.dll" alias "_ODE_dJointSetUniversalParam@12" (byval joint as integer, byval parameter as integer, byval value as single)
declare sub ODE_dJointSetAMotorParam lib "ODE.dll" alias "_ODE_dJointSetAMotorParam@12" (byval joint as integer, byval parameter as integer, byval value as single)
declare function ODE_dJointGetHingeParam lib "ODE.dll" alias "_ODE_dJointGetHingeParam@8" (byval joint as integer, byval parameter as integer) as single
declare function ODE_dJointGetSliderParam lib "ODE.dll" alias "_ODE_dJointGetSliderParam@8" (byval joint as integer, byval parameter as integer) as single
declare function ODE_dJointGetHinge2Param lib "ODE.dll" alias "_ODE_dJointGetHinge2Param@8" (byval joint as integer, byval parameter as integer) as single
declare function ODE_dJointGetUniversalParam lib "ODE.dll" alias "_ODE_dJointGetUniversalParam@8" (byval joint as integer, byval parameter as integer) as single
declare function ODE_dJointGetAMotorParam lib "ODE.dll" alias "_ODE_dJointGetAMotorParam@8" (byval joint as integer, byval parameter as integer) as single
declare sub ODE_dJointAddHingeTorque lib "ODE.dll" alias "_ODE_dJointAddHingeTorque@8" (byval joint as integer, byval torque as single)
declare sub ODE_dJointAddUniversalTorques lib "ODE.dll" alias "_ODE_dJointAddUniversalTorques@12" (byval joint as integer, byval torque1 as single, byval torque2 as single)
declare sub ODE_dJointAddSliderForce lib "ODE.dll" alias "_ODE_dJointAddSliderForce@8" (byval joint as integer, byval force as single)
declare sub ODE_dJointAddHinge2Torques lib "ODE.dll" alias "_ODE_dJointAddHinge2Torques@12" (byval joint as integer, byval torque1 as single, byval torque2 as single)
declare sub ODE_dJointAddAMotorTorques lib "ODE.dll" alias "_ODE_dJointAddAMotorTorques@16" (byval joint as integer, byval torque0 as single, byval torque1 as single, byval torque2 as single)
declare sub ODE_dGeomDestroy lib "ODE.dll" alias "_ODE_dGeomDestroy@4" (byval geom as integer)
declare sub ODE_dGeomSetBody lib "ODE.dll" alias "_ODE_dGeomSetBody@8" (byval geom as integer, byval body as integer)
declare sub ODE_dGeomSetPosition lib "ODE.dll" alias "_ODE_dGeomSetPosition@16" (byval geom as integer, byval x as single, byval y as single, byval z as single)
declare sub ODE_dGeomSetRotation lib "ODE.dll" alias "_ODE_dGeomSetRotation@16" (byval geom as integer, byval x as single, byval y as single, byval z as single)
declare function ODE_dGeomGetPositionX lib "ODE.dll" alias "_ODE_dGeomGetPositionX@4" (byval geom as integer) as double
declare function ODE_dGeomGetPositionY lib "ODE.dll" alias "_ODE_dGeomGetPositionY@4" (byval geom as integer) as double
declare function ODE_dGeomGetPositionZ lib "ODE.dll" alias "_ODE_dGeomGetPositionZ@4" (byval geom as integer) as double
declare function ODE_dGeomGetPitch lib "ODE.dll" alias "_ODE_dGeomGetPitch@4" (byval geom as integer) as double

declare function ODE_dGeomGetYaw lib "ODE.dll" alias "_ODE_dGeomGetYaw@4" (byval geom as integer) as double
declare function ODE_dGeomGetRoll lib "ODE.dll" alias "_ODE_dGeomGetRoll@4" (byval geom as integer) as double
declare function ODE_dHashSpaceCreate lib "ODE.dll" alias "_ODE_dHashSpaceCreate@4" (byval space as integer) as integer
declare function ODE_dSimpleSpaceCreate lib "ODE.dll" alias "_ODE_dSimpleSpaceCreate@4" (byval space as integer) as integer
declare sub ODE_dSpaceSetCleanup lib "ODE.dll" alias "_ODE_dSpaceSetCleanup@8" (byval space as integer, byval mode as integer)
declare sub ODE_dSpaceAdd lib "ODE.dll" alias "_ODE_dSpaceAdd@8" (byval space as integer, byval geom as integer)
declare sub ODE_dSpaceRemove lib "ODE.dll" alias "_ODE_dSpaceRemove@8" (byval space as integer, byval geom as integer)
declare function ODE_dCreateBox lib "ODE.dll" alias "_ODE_dCreateBox@20" (byval space as integer, byval width as single, byval height as single, byval depth as single, byval mass as single) as integer
declare function ODE_dCreateSphere lib "ODE.dll" alias "_ODE_dCreateSphere@12" (byval space as integer, byval radius as single, byval mass as single) as integer
declare function ODE_dCreateCCylinder lib "ODE.dll" alias "_ODE_dCreateCCylinder@16" (byval space as integer, byval radius as single, byval height as single, byval mass as single) as integer
declare function ODE_dGeomTriMeshDataCreate lib "ODE.dll" alias "_ODE_dGeomTriMeshDataCreate@0" () as integer
declare sub ODE_dGeomTriMeshDataDestroy lib "ODE.dll" alias "_ODE_dGeomTriMeshDataDestroy@4" (byval data as integer)
declare sub ODE_dGeomTriMeshDataBuildSimple lib "ODE.dll" alias "_ODE_dGeomTriMeshDataBuildSimple@20" (byval data as integer, byval vertices as single, byval VertexCount as integer, byval indices as integer, byval indexcount as integer)
declare function ODE_dCreateTriMesh lib "ODE.dll" alias "_ODE_dCreateTriMesh@8" (byval space as integer, byval data as integer) as integer

