' Direct 3D example with ODE for Rapid-Q by Julien Moog - julien.moog@laposte.net
' Control the ball (Marble Madness-like)

$TYPECHECK on
$optimize on
$apptype console
$option explicit

$include "RapidQ_ODE.inc"
$include "RapidQ_D3D.inc"

$RESOURCE RES_BMP1 AS "waterbg.bmp"

declare sub onkeydownsub(key as word,shift as integer)
declare sub onkeyupsub(key as word,shift as integer)
declare sub keydowntimersub
declare sub setbounce(bouncesingle as single)
declare sub setmu2(MUsingle as single)
declare sub setsoft_erp(SOFT_ERPsingle as single)
declare sub SetSOFT_CFM(SOFT_CFMsingle as single)
declare sub SetBOUNCE_VEL(BOUNCE_VELsingle as single)
declare sub SetSLIP1(SLIP1single as single)
declare sub SetSLIP2(SLIP2single as single)
declare sub SetMU(MUsingle as single)
declare sub SetMOTION1(MOTION1single as single)
declare sub SetMOTION2(MOTION2single as single)
declare function dxdrawtriangle(x as single,y as single,z as single) as integer
DECLARE Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" _ 
(ByVal lpstrCommand As String, _
ByVal lpstrReturnString As String, _
ByVal uReturnLength As Long, _ 
ByVal hwndCallback As Long) As Long
DECLARE SUB DXInitialize(Sender AS QDXScreen)
DECLARE SUB DXInitializeSurface(Sender AS QDXScreen)
DECLARE SUB DXTimerExpired
DECLARE SUB DXMouseMove (X AS INTEGER, Y AS INTEGER)
declare sub engine_initialize
declare sub engine_update
declare sub closefrm
declare sub showdirectives

CONST alClient = 5 
const nbballs=3

' ----------------- form handle settings
dim keydowntimer as qtimer
keydowntimer.enabled=0
keydowntimer.interval=15
keydowntimer.ontimer=keydowntimersub
dim keypressed as integer

' some color codes
const yellow1 = &H22DDDD 
const green1 = &H118811 
const red1 = &H1111AA
const orange1 = &H4477CC

' font styles
DIM infocanvasimgFont AS QFONT
infocanvasimgFont.Name = "arial"
infocanvasimgFont.size=10
infocanvasimgFont.AddStyles(fsBold)
DIM gamecanvasimgFont AS QFONT
gamecanvasimgFont.Name = "arial"
gamecanvasimgFont.size=15
gamecanvasimgFont.AddStyles(fsBold)

dim gamecanvaschoice as integer
gamecanvaschoice=1

' ----------------------------

' ------------------- Global variables for ODE

defsng worldstepsingle=1/30
defint iworldstepsingle
memcpy(varptr(iworldstepsingle),varptr(worldstepsingle),4)

' mass of the ball
defsng masssingle=0.4
defint imasssingle
memcpy(varptr(imasssingle),varptr(masssingle),4)

dim ballpushforce as single
ballpushforce=9

dim GRAVITY as single
gravity=-9.81 ' earth 9.81

dim ballcolltmp(100) as integer
dim ballcolltmp2(100) as integer
'-----------------------------------------

' ---------------------------- setup subs for ODE

' bounce setup sub
sub setbounce(bouncesingle as single)
defsng bouncesingle2=bouncesingle
defint ibouncesingle
memcpy(varptr(ibouncesingle),varptr(bouncesingle2),4)
ODE_dSetBOUNCE(ibouncesingle)
end sub

' friction setup sub
sub setmu2(MUsingle as single)
defsng MUsingle2=MUsingle
defint iMUsingle
memcpy(varptr(iMUsingle),varptr(MUsingle2),4)
ODE_dSetMU2(iMUsingle) ' Friction
end sub

'  erp setup sub
sub setsoft_erp(SOFT_ERPsingle as single)
defsng SOFT_ERPsingle2=SOFT_ERPsingle
defint iSOFT_ERPsingle
memcpy(varptr(iSOFT_ERPsingle),varptr(SOFT_ERPsingle2),4)
ODE_dSetSOFT_ERP(iSOFT_ERPsingle)
end sub

' cfm setup sub
sub SetSOFT_CFM(SOFT_CFMsingle as single)
defsng SOFT_CFMsingle2=SOFT_CFMsingle
defint iSOFT_CFMsingle
memcpy(varptr(iSOFT_CFMsingle),varptr(SOFT_CFMsingle2),4)
ODE_dSetSOFT_CFM(iSOFT_CFMsingle)
end sub

' bounce setup sub
sub SetBOUNCE_VEL(BOUNCE_VELsingle as single)
defsng BOUNCE_VELsingle2=BOUNCE_VELsingle
defint iBOUNCE_VELsingle
memcpy(varptr(iBOUNCE_VELsingle),varptr(BOUNCE_VELsingle2),4)
ODE_dSetSOFT_CFM()
end sub

' slip1 setup sub
sub SetSLIP1(SLIP1single as single)
defsng SLIP1single2=SLIP1single
defint iSLIP1single
memcpy(varptr(iSLIP1single),varptr(SLIP1single2),4)
ODE_dSetSOFT_CFM()
end sub

' slip2 setup sub
sub SetSLIP2(SLIP2single as single)
defsng SLIP2single2=SLIP2single
defint iSLIP2single
memcpy(varptr(iSLIP2single),varptr(SLIP2single2),4)
ODE_dSetSOFT_CFM()
end sub

' mu setup sub
sub SetMU(MUsingle as single)
defsng MUsingle2=MUsingle
defint iMUsingle
memcpy(varptr(iMUsingle),varptr(MUsingle2),4)
ODE_dSetSOFT_CFM()
end sub

' motion1 setup sub
sub SetMOTION1(MOTION1single as single)
defsng MOTION1single2=MOTION1single
defint iMOTION1single
memcpy(varptr(iMOTION1single),varptr(MOTION1single2),4)
ODE_dSetSOFT_CFM()
end sub

' motion2 setup sub
sub SetMOTION2(MOTION2single as single)
defsng MOTION2single2=MOTION2single
defint iMOTION2single
memcpy(varptr(iMOTION2single),varptr(MOTION2single2),4)
ODE_dSetSOFT_CFM()
end sub
' ------------------------------- 

' -------------------------- DirectX settings
DIM DXTimer AS QDXTimer
DXTimer.Enabled = 0
DXTimer.Interval = 0
DXTimer.OnTimer = DXTimerExpired    

' -------------------- Global 3D objects variables for dxscreen

dim SphereFrame_initialposx as single
dim SphereFrame_initialposy as single
dim SphereFrame_initialposz as single
SphereFrame_initialposx=0
SphereFrame_initialposy=15
SphereFrame_initialposz=0

dim SphereFrame_initialrotx as single
dim SphereFrame_initialroty as single
dim SphereFrame_initialrotz as single
dim SphereFrame_anglerot as single
SphereFrame_initialrotx=0
SphereFrame_initialroty=0
SphereFrame_initialrotz=0
SphereFrame_anglerot=0

dim cameraposzz as integer
cameraposz=-60

DIM triangle             AS QD3DPrimitive    'our player 1 paddle
dim triangleid as integer:triangleid=0

DIM SphereFrame(100) AS QD3DFrame
DIM wrap_grass AS QD3DWRAP
DIM wrap AS QD3DWRAP
' ----------------------------------------------------

' ---------------------------------------------------------

' ------------------------ ODE initialization

' create world and set gravity
dim space
space = ODE_dWorldCreate(1)
ODE_dWorldSetGravity(0,gravity,0)

'possible arguments for ODE_dSetContactMode() are:
'dContactMu2 ' friction
'dContactFDir1
'dContactBounce
'dContactSoftERP
'dContactSoftCFM ' sinking
'dContactMotion1
'dContactMotion2
'dContactSlip1
'dContactSlip2
'dContactApprox0
'dContactApprox1_1
'dContactApprox1_2
'dContactApprox1

ODE_dSetContactMode(dContactBounce + dContactSoftERP)
SetSOFT_ERP(0.8)
SetBOUNCE(0.7)
'SetSOFT_CFM()
'SetBOUNCE_VEL()
'SetSLIP1()
'SetSLIP2()
'SetMU()
'SetMU2()
'SetMOTION1()
'SetMOTION2()

' the ground (wood board), are an static object (geom only)
dim geomboard
geomboard=ODE_dCreateBox(space, 28,3.5,28.5, 0)
ODE_dGeomSetPosition(geomboard, 0, 0, 0)
dim geomtree
geomtree=ODE_dCreateBox(space, 0.5,50,0.5, 0) 
ODE_dGeomSetPosition(geomtree, 25, 0, 30)
dim geomrock
geomrock=ODE_dCreateBox(space, 10,1,0.95, 0) 
ODE_dGeomSetPosition(geomrock, 10,0,35)

dim i as integer
dim bodysphere(100)
dim geomsphere(100)

for i=1 to nbballs

bodysphere(i)=ODE_dBodyCreate()
geomsphere(i)=ODE_dCreateSphere(space, 1.1, 0) ' space,radius,mass (mass do not work we will set it with ODE_dBodySetMass
ODE_dBodySetMass(bodysphere(i), imasssingle)
ODE_dGeomSetBody geomsphere(i), bodysphere(i)
ODE_dBodySetPosition(bodysphere(i), SphereFrame_initialposx+3+i*3, SphereFrame_initialposy, SphereFrame_initialposz)
ODE_dBodySetRotation(bodysphere(i), SphereFrame_initialrotx, SphereFrame_initialroty, SphereFrame_initialrotz)
ODE_dBodyAddForce(bodysphere(i),0,0,20)

next i

' ------------------------------------------

' ------------------------------- music mp3 player
DIM ret AS Long
DIM mp3file AS String
DIM Play AS String
DIM Cmd AS String

mp3file = command$(1)
Cmd = "Open " & chr$(34) & mp3file & chr$(34) & " Alias Rapid-MP3"
Play = "Play rapid-mp3"
' ---------------------------------------------------



CREATE Form AS QForm
    Caption = "Control the ball"
    Center
    width=800
    height=600
    onkeydown=onkeydownsub
    onkeyup=onkeyupsub    
    onclose=closefrm 
    
    create bouncesnd as qdxsound
    end create
    create menusnd as qdxsound
    end create
    create rollsnd as qdxsound
    end create    
       
    CREATE DXScreen AS QDXScreen
        BitCount = 16
        width = Form.ClientWidth
        height = Form.ClientHeight
        Init(640, 480)  'define its memory, can be larger than visible screen
        Align = alClient
        Use3D = 1
        UseHardware = 1        '' This is for 3D accelerated video cards.
        fullScreen = 0
        OnInitialize = DXInitialize
        OnInitializeSurface = DXInitializeSurface
        OnMouseMove = DXMouseMove        
    END CREATE
    
    create infocanvas as qpanel
    parent=form
    top=0
    left=0
    height=0
    width=0
    visible=0
    create infocanvasimg as qimage
    height=infocanvas.height
    width=infocanvas.width
    Autosize = True
    stretch=1    
    font=infocanvasimgFont
    end create
    end create
    
    create gamecanvas as qpanel
    parent=form
    top=0
    left=0
    height=0
    width=0
    visible=0
    create gamecanvasimg as qimage
    height=gamecanvas.height
    width=gamecanvas.width
    Autosize = True
    stretch=1    
    font=gamecanvasimgFont
    end create    
    end create           
    
END CREATE      

' --------------------------- dx sounds settings  
    with bouncesnd
        .filename=curdir$+"\bounce.wav"
        .frequency=22050    
        .looped=0
        .position=0
        .volume=100    
    end with
    
    with menusnd
        .filename=curdir$+"\fx_025_2.wav"
        .frequency=44100    
        .looped=0
        .position=0
        .volume=100    
    end with
    
    with rollsnd
        .filename=curdir$+"\roll.wav"
        .frequency=33075    
        .looped=1
        .position=0
        .volume=0    
    end with
' -----------------------------  

form.showmodal

' ----------------------- form subs
sub showdirectives
infocanvas.height=170
infocanvas.width=294
infocanvas.top=45
infocanvas.left=20
infocanvasimg.BMPHandle = RES_BMP1  
infocanvasimg.textout(5,5,"Take control of the ball", red1, -1)
infocanvasimg.TextOut(5,19,"Press key left to turn left", red1, -1)
infocanvasimg.TextOut(5,33,"Press key right to turn right", red1, -1)
infocanvasimg.TextOut(5,47,"Press key down to move back", red1, -1)
infocanvasimg.TextOut(5,61,"Press key up to run", red1, -1)
infocanvasimg.TextOut(5,75,"Press - for zoom -", red1, -1)
infocanvasimg.TextOut(5,89,"Press + for zoom +", red1, -1)
infocanvasimg.TextOut(5,103,"Press r to reset the ball", red1, -1)
infocanvasimg.TextOut(5,117,"Press h to hide/show this message", red1, -1)
infocanvasimg.TextOut(5,131,"Pres Esc to hide/show the game menu", red1, -1)  
infocanvasimg.TextOut(5,145,"(c) 2011 - julien.moog@laposte.net", red1, -1)  
infocanvasimg.height=infocanvas.height
infocanvasimg.width=infocanvas.width 
infocanvas.visible=1
end sub

' --------------------------------

' ----------------------- subs for dx (placed here because DXScreen must be declared above)

function dxdrawtriangle(x as single,y as single,z as single) as integer
triangleid++
dXScreen.CreateFrame(triangle.Frame(triangleid))             'holds 3d transformation matrix
    WITH triangle
    .Frame(triangleid).AddVisual(triangle.Mesh)                  'put paddle on its own frame for movement
    .Frame(triangleid).SetPosition(x, y, z)
    END WITH     
result=triangleid
end function
' ------------------------------------------ 

           

SUB DXInitialize(Sender AS QDXScreen)

    DXScreen.CreateMeshBuilder(triangle.Mesh)        'hold vertices    

    WITH triangle ' not used yet but can be useful
       .MakePyramid (DXScreen)
       .Mesh.Scale(0.5, 0.5, 0.5)
       .DrawCenter.y = 0
       .ViewFromOutside = True                         'view from outside       
       .Mesh.SetRGB(0.3, 0.6, 0.3)
    END WITH        

   DXScreen.SetTextureQuality = D3DRMTEXTURE_MIPNEAREST
   
   ' open mp3 and play it
    'mp3file="" ' put your mp3 filename here
    'Cmd = "Open "& chr$(34) & mp3file & chr$(34) & " Alias Rapid-MP3"
    'ret = mciSendString(Cmd, 0, 0, 0)
    'ret = mciSendString(Play, 0, 0, 0)
        
   DIM Light AS QD3DLight
   DIM Shadow AS QD3DVisual
   DIM LightFrame AS QD3DFrame, SceneFrame AS QD3DFrame
   DIM PlaneFrame AS QD3DFrame
   dim boardframe as QD3DFrame
   dim MeshFramesky as QD3DFrame
   DIM SceneMeshBuilder AS QD3DMeshBuilder      
   dim ObjectMesh AS QD3DMeshBuilder  
   dim playermesh AS QD3DMeshBuilder  
   dim boardmesh as qd3dmeshbuilder
   dim MeshBuildersky as qd3dmeshbuilder
   DIM MeshFrametrees(2) AS QD3DFrame
   DIM MeshBuildertrees(2) AS QD3DMeshBuilder
   DIM Shadow_trees AS QD3DVisual
   DIM MeshFramerocks(2) AS QD3DFrame
   DIM MeshBuilderrocks(2) AS QD3DMeshBuilder
   DIM Shadow_rocks AS QD3DVisual      

   DXScreen.CreateMeshBuilder(SceneMeshBuilder)
   DXScreen.CreateMeshBuilder(ObjectMesh)
   DXScreen.CreateMeshBuilder(PlayerMesh)
   DXScreen.CreateMeshBuilder(boardMesh)
   DXScreen.CreateMeshBuilder(MeshBuildersky)
   

   DXScreen.CreateFrame(LightFrame)
   DXScreen.CreateFrame(SceneFrame)
   DXScreen.CreateFrame(PlaneFrame)   
   DXScreen.CreateFrame(boardFrame)
   DXScreen.CreateFrame(MeshFramesky)

   DXScreen.SetCameraPosition(0, 15, cameraposz)
   DXScreen.SetCameraOrientation(0, 0, 1, 0, 1, 0)   

   DXScreen.CreateLightRGB(D3DRMLIGHT_AMBIENT, 0.9, 0.9, 0.9, Light)
   DXScreen.AddLight(Light)

   DXScreen.CreateLightRGB(D3DRMLIGHT_SPOT, 1, 1, 1, Light)
   Light.SetPenUmbra(0.2)
   Light.SetUmbra(0.15)
   Light.SetRange(40)
   
   MeshBuildersky.Load("sky_piramid1.x")
   MeshBuildersky.Scale(15, 15, 15)
   MeshBuildersky.SetQuality(D3DRMRENDER_MAX)
   MeshFramesky.AddVisual(MeshBuildersky)
   MeshFramesky.SetPosition(0, -10, 0)
   MeshFramesky.SetRotation(0, 0, 0,0)
   meshBuildersky.loadTexture("sky.bmp")
   dxScreen.createWrap(D3DRMWRAP_CHROME, 0,0,0, 0,0,1, 0,1,0, .5,.5, 0,.75, wrap)
   wrap.apply(meshBuildersky)

   SceneMeshBuilder.Load("terrainbig.x")
   SceneMeshBuilder.Scale(3,3,3)
   SceneMeshBuilder.SetQuality(D3DRMRENDER_MAX)
   SceneFrame.AddVisual(SceneMeshBuilder)
   SceneFrame.setposition(0,0,0)
   SceneFrame.SetRotation(0, 0, 0,0)
   SceneMeshBuilder.loadTexture("grass1.bmp")
   dxScreen.createWrap(D3DRMWRAP_CHROME, 0,0,0,0,0,1,0,1,0,.5,.5,1,1, wrap_grass)
   wrap_grass.apply(SceneMeshBuilder)
   
   DXScreen.CreateFrame(MeshFrametrees(1))
   DXScreen.CreateMeshBuilder(MeshBuildertrees(1))
   dim wrap_trees as qd3dwrap   
    MeshBuildertrees(1).Load("albero2.x")
    MeshBuildertrees(1).Scale(.4,.4,.4)
    MeshBuildertrees(1).SetQuality(D3DRMRENDER_MAX)
    MeshFrametrees(1).AddVisual(MeshBuildertrees(1))
    MeshFrametrees(1).SetPosition(25,0,30)
    MeshFrametrees(1).SetRotation(0, 0, 0,0)
    DXScreen.CreateShadow(MeshBuildertrees(1), Light ,0, -.2, 0, 0, .2, 0 ,Shadow_trees)
    MeshFrametrees(1).AddVisual(Shadow_trees)
    
    DXScreen.CreateFrame(MeshFramerocks(1))
    DXScreen.CreateMeshBuilder(MeshBuilderrocks(1))   
    MeshBuilderrocks(1).Load("ball.x")
    MeshBuilderrocks(1).Scale(0.7,0.2,0.1)
    MeshBuilderrocks(1).SetQuality(D3DRMRENDER_MAX)
    MeshFramerocks(1).AddVisual(MeshBuilderrocks(1))
    MeshFramerocks(1).SetPosition(10,0.1,35)
    MeshFramerocks(1).SetRotation(0, 0, 0,0)
    MeshBuilderrocks(1).loadTexture("stone.bmp")
    DXScreen.CreateShadow(MeshBuilderrocks(1), Light ,0, -.2, 0, 0, .2, 0 ,Shadow_rocks)
    MeshFramerocks(1).AddVisual(Shadow_rocks)

   
   boardMesh.Load("plane.x")  
   boardMesh.Scale(3,3,3)
   boardMesh.SetQuality(D3DRMRENDER_MAX)
   boardFrame.AddVisual(boardMesh)
   boardFrame.setposition(0,1,0)
   boardFrame.SetRotation(0, 0, 0,0)
   boardMesh.loadTexture("wood.bmp")       
   
   ObjectMesh.Load("ball.x")
   ObjectMesh.Scale(0.123,0.123,0.123)
   ObjectMesh.SetQuality(D3DRMRENDER_MAX)
   ObjectMesh.loadTexture("balltexture2.bmp")
   'dxScreen.createWrap(D3DRMWRAP_CHROME, 0,0,0,0,0,1,0,1,0,.5,.5,1,1, wrap)
   'wrap.apply(ObjectMesh)    
   
   playerMesh.Load("ball.x")
   playerMesh.Scale(0.123,0.123,0.123)
   playerMesh.SetQuality(D3DRMRENDER_MAX)
   playerMesh.loadTexture("balltexture.bmp")
   
   DXScreen.CreateShadow(ObjectMesh, Light, 0, 2, 0, 0,2, 0, Shadow) 
   
   LightFrame.AddLight(Light)
   LightFrame.SetPosition(0,30,0)   
   
  
   dim i as integer
   for i=1 to nbballs
   DXScreen.CreateFrame(SphereFrame(i))
   if i=1 then ' player controls the first ball
   SphereFrame(i).AddVisual(PlayerMesh)
   else
   SphereFrame(i).AddVisual(ObjectMesh)
   end if
   'SphereFrame(i).AddVisual(Shadow) ' not actived yet because we need to set shadow position y      
   SphereFrame(i).SetPosition(SphereFrame_initialposx,SphereFrame_initialposy,SphereFrame_initialposz)
   SphereFrame(i).SetRotation(SphereFrame_initialrotx,SphereFrame_initialroty,SphereFrame_initialrotz,SphereFrame_anglerot)
   next i
    
   'SceneMeshBuilder.SetQuality(D3DRMRENDER_WIREFRAME)
   'ObjectMesh.SetQuality(D3DRMRENDER_WIREFRAME)
   
   ' open mp3 and play it
    mp3file="Jul-Zen_-_Delighted_World.mp3" ' put your mp3 filename here
    Cmd = "Open "& chr$(34) & mp3file & chr$(34) & " Alias Jul-Zen_-_Delighted_World"
    ret = mciSendString(Cmd, 0, 0, 0)
    ret = mciSendString("Play Jul-Zen_-_Delighted_World", 0, 0, 0) 
    
    showdirectives
    
    rollsnd.play
       
END SUB




SUB DXInitializeSurface(Sender AS QDXScreen)
   DXScreen.SetRenderMode(D3DRMRENDERMODE_BLENDEDTRANSPARENCY OR D3DRMRENDERMODE_SORTEDTRANSPARENCY)
   dxtimer.enabled=1   
END SUB

SUB DXTimerExpired

dim i as integer
dim bodyposx as double
dim bodyposy as double
dim bodyposz as double
dim bodyrotx as double
dim bodyroty as double
dim bodyrotz as double
dim bodyvel() as double

for i=1 to nbballs

bodyposx=ODE_dGeomGetPositionX(geomsphere(i))
bodyposy=ODE_dGeomGetPositionY(geomsphere(i))
bodyposz=ODE_dGeomGetPositionZ(geomsphere(i))
SphereFrame(i).SetPosition(bodyposx, bodyposy, bodyposz)
bodyvel(i)=abs(ODE_dBodyGetLinearVelX(bodysphere(i)))+abs(ODE_dBodyGetLinearVelZ(bodysphere(i)))
bodyrotx=ODE_dBodyGetAngularVelX(bodysphere(i))
bodyroty=ODE_dBodyGetAngularVelY(bodysphere(i))
bodyrotz=ODE_dBodyGetAngularVelZ(bodysphere(i))
SphereFrame(i).SetRotation(bodyrotx,bodyroty,bodyrotz,bodyvel(i)/50)

if i=1 then
    DXScreen.SetCameraPosition(bodyposx, bodyposy+10, bodyposz+cameraposz) 
end if

ballcolltmp(i)=ODE_dBodyGetCollisionsCount(bodysphere(i))

if (ballcolltmp(i)>ballcolltmp2(i)) then
bouncesnd.position=0
bouncesnd.play
end if

ballcolltmp2(i)=ballcolltmp(i)

next i  

rollsnd.frequency=33075+bodyvel(1)*1000
rollsnd.volume=80+log(1+bodyvel(1))*4

   'dxscreen.fill(0) ' fill screen with color   
   'DXScreen.ForceUpdate(0,0,40,40)    ' Update FPS text only    
   DXScreen.Render ' display DirectX
   DXScreen.Move(1) ' animate objects         
   DXScreen.Flip    
   engine_update ' update ODE step

END SUB

SUB DXMouseMove (X AS INTEGER, Y AS INTEGER)
   'sphereFrame(0).SetPosition(0, -(Y-100)/5, 0)
   'sphereframe_getposition(0).y=-(Y-100)/5
'   DXScreen.SetCameraOrientation(0, 0, x/1000, 0, 1, 0)  
'   print x
   'DXScreen.Render
END SUB

sub engine_update

ODE_dWorldQuickStep iworldstepsingle ' makes ODE compute a step with specified duration

end sub

sub closefrm
    ODE_dCloseODE ' deinitialize ODE
end sub

sub onkeydownsub(key as word,shift as integer)

if key=82 then ' key "r"
if gamecanvas.visible=1 then
exit sub
end if
ODE_dBodySetForce(bodysphere(1),0,0,0)
ODE_dBodySetLinearVel(bodysphere(1),0,0,0)
ODE_dBodySetAngularVel(bodysphere(1),0,0,0) 
ODE_dBodySetRotation(bodysphere(1),0,0,0) 
ODE_dBodySetPosition(bodysphere(1), SphereFrame_initialposx, SphereFrame_initialposy, SphereFrame_initialposz)
ODE_dBodySetRotation(bodysphere(1), SphereFrame_initialrotx, SphereFrame_initialroty, SphereFrame_initialrotz)
ODE_dBodyAddForce(bodysphere(i),0,0,-20)
end if

if ((key=37 or key=39 or key=40 or key=38 or key=32 or key=109 or key=107) and keydowntimer.enabled=0) then
if gamecanvas.visible=0 then
keypressed=key
keydowntimer.enabled=1
end if
end if

if key=72 then
if infocanvas.visible=1 then
infocanvas.visible=0
menusnd.position=0
menusnd.play
exit sub
end if
if infocanvas.visible=0 then
showdirectives
menusnd.position=0
menusnd.play
exit sub
end if
end if

if key=27 then
if gamecanvas.visible=1 then
gamecanvas.visible=0
' stop mp3 and close it
mp3h = MciSendString("Stop Jul-Zen_-_Time", 0,0, 0)
mp3h = MciSendString("Close Jul-Zen_-_Time", 0,0, 0)
' open mp3 and play it
    mp3file="Jul-Zen_-_Delighted_World.mp3" ' put your mp3 filename here
    Cmd = "Open "& chr$(34) & mp3file & chr$(34) & " Alias Jul-Zen_-_Delighted_World"
    ret = mciSendString(Cmd, 0, 0, 0)
    ret = mciSendString("Play Jul-Zen_-_Delighted_World", 0, 0, 0)    
menusnd.position=0
menusnd.play
rollsnd.looped=1
rollsnd.play
dxtimer.enabled=1
exit sub
end if
if gamecanvas.visible=0 then
dxtimer.enabled=0
rollsnd.volume=0
rollsnd.looped=0
gamecanvas.width=294
gamecanvas.height=170
gamecanvas.left=form.width/2-gamecanvas.width/2
gamecanvas.top=form.height/2-gamecanvas.height/2
gamecanvasimg.BMPHandle = RES_BMP1
gamecanvasimg.textout(60,40,"Continue game", orange1, -1)
gamecanvasimg.textout(60,60,"Give up", red1, -1)
gamecanvasimg.textout(60,80,"Quit", red1, -1)
gamecanvasimg.height=gamecanvas.height
gamecanvasimg.width=gamecanvas.width
gamecanvas.visible=1
menusnd.position=0
menusnd.play
' stop mp3 and close it
mp3h = MciSendString("Stop Jul-Zen_-_Delighted_World", 0,0, 0)
mp3h = MciSendString("Close Jul-Zen_-_Delighted_World", 0,0, 0)
' open mp3 and play it
mp3file="Jul-Zen_-_Time.mp3" ' put your mp3 filename here
Cmd = "Open "& chr$(34) & mp3file & chr$(34) & " Alias Jul-Zen_-_Time"
ret = mciSendString(Cmd, 0, 0, 0)
ret = mciSendString("Play Jul-Zen_-_Time", 0, 0, 0)    
exit sub
end if
end if

if gamecanvas.visible=1 then
select case key
case 40:
gamecanvaschoice++
if gamecanvaschoice>3 then
gamecanvaschoice=1
end if
bouncesnd.position=0
bouncesnd.play
case 38:
gamecanvaschoice--
if gamecanvaschoice<1 then
gamecanvaschoice=3
end if
bouncesnd.position=0
bouncesnd.play
case 13:
select case gamecanvaschoice
case 1:
gamecanvas.visible=0
' stop mp3 and close it
mp3h = MciSendString("Stop Jul-Zen_-_Time", 0,0, 0)
mp3h = MciSendString("Close Jul-Zen_-_Time", 0,0, 0)
' open mp3 and play it
    mp3file="Jul-Zen_-_Delighted_World.mp3" ' put your mp3 filename here
    Cmd = "Open "& chr$(34) & mp3file & chr$(34) & " Alias Jul-Zen_-_Delighted_World"
    ret = mciSendString(Cmd, 0, 0, 0)
    ret = mciSendString("Play Jul-Zen_-_Delighted_World", 0, 0, 0)    
menusnd.position=0
menusnd.play
rollsnd.looped=1
rollsnd.play
dxtimer.enabled=1
exit sub
case 2:

case 3:
end
end select
end select
select case gamecanvaschoice
case 1:
gamecanvasimg.BMPHandle = RES_BMP1
gamecanvasimg.textout(60,40,"Continue game", orange1, -1)
gamecanvasimg.textout(60,60,"Give up", red1, -1)
gamecanvasimg.textout(60,80,"Quit", red1, -1)
gamecanvasimg.height=gamecanvas.height
gamecanvasimg.width=gamecanvas.width
case 2:
gamecanvasimg.BMPHandle = RES_BMP1
gamecanvasimg.textout(60,40,"Continue game", red1, -1)
gamecanvasimg.textout(60,60,"Give up", orange1, -1)
gamecanvasimg.textout(60,80,"Quit", red1, -1)
gamecanvasimg.height=gamecanvas.height
gamecanvasimg.width=gamecanvas.width
case 3:
gamecanvasimg.BMPHandle = RES_BMP1
gamecanvasimg.textout(60,40,"Continue game", red1, -1)
gamecanvasimg.textout(60,60,"Give up", red1, -1)
gamecanvasimg.textout(60,80,"Quit", orange1, -1)
gamecanvasimg.height=gamecanvas.height
gamecanvasimg.width=gamecanvas.width
end select
end if

end sub

sub onkeyupsub(key as word,shift as integer)

keydowntimer.enabled=0

end sub

sub keydowntimersub

if keypressed=37 then ' pav num 4 left
if ballcolltmp(1)>0 then
ODE_dBodyAddForce(bodysphere(1),-ballpushforce,0,0)
end if
end if

if keypressed=39 then ' pav num 6 right
if ballcolltmp(1)>0 then
ODE_dBodyAddForce(bodysphere(1),ballpushforce,0,0)
end if
end if

if keypressed=40 then ' pav num 5 down
if ballcolltmp(1)>0 then
ODE_dBodyAddForce(bodysphere(1),0,0,-ballpushforce)
end if
end if

if keypressed=38 then ' pav num 8 up
if ballcolltmp(1)>0 then
ODE_dBodyAddForce(bodysphere(1),0,0,ballpushforce)
end if
end if

'if keypressed=32 then ' space bar for cheating purposes
'ODE_dBodyAddForce(bodysphere(1),0,ballpushforce,0)
'end if

if keypressed=109 then ' key "-"
cameraposz--
end if

if keypressed=107 then ' key "+"
cameraposz++
end if

end sub
